using System.Web;
using System.Data;
using System.Data.OleDb;
using System.IO;
using NPOI.SS.UserModel;
using System;
using NPOI.HSSF.UserModel;

namespace testDemoNpoi
{
    public abstract class ExcelHelper
    {
        /// <summary>
        /// һNPOI
        /// </summary>
        public static HSSFWorkbook CreateWorkbook(string TemplateUrl)
        {
            HSSFWorkbook hssfworkbook;
            using (FileStream file = new FileStream(HttpContext.Current.Server.MapPath(TemplateUrl), FileMode.Open, FileAccess.Read))
            {
                //NPOI                
                hssfworkbook = new HSSFWorkbook(file);
                file.Close();
            }
            return hssfworkbook;
        }


        /// <summary>
        /// DataSetеݵExcel
        /// </summary>
        /// <param name="ds">ҪݣDataSetʽ</param>
        /// <param name="TemplateUrl">ģļ·</param>
        /// <param name="SheetName"></param>
        /// <param name="HeaderRowIndex">ͷ</param>
        /// <returns></returns>
        public static HSSFWorkbook DataSetExportToExcel(DataSet ds, string TemplateUrl, string SheetName,int HeaderRowIndex)
        {

            HSSFWorkbook hssfworkbook = CreateWorkbook(TemplateUrl);
            if (SheetName == "")
            {
                SheetName = "Sheet1";
            }
            ISheet sheet = hssfworkbook.GetSheet(SheetName);

            using (FileStream file = new FileStream(HttpContext.Current.Server.MapPath(TemplateUrl), FileMode.Open, FileAccess.Read))
            {
                IRow dataRow;
                for (int i = 0; i < ds.Tables[0].Rows.Count; i++)
                {
                    dataRow = sheet.CreateRow(i + HeaderRowIndex + 2);
                    dataRow.HeightInPoints = sheet.GetRow(HeaderRowIndex + 1).HeightInPoints;
                    for (int j = 0; j < ds.Tables[0].Columns.Count; j++)
                    {
                        if (ds.Tables[0].Rows[i][j].ToString().Trim() == "")
                        {
                            continue;
                        }

                        switch (ds.Tables[0].Columns[j].DataType.ToString())
                        {
                            case "System.Int16"://integer
                            case "System.Int32":
                            case "System.Int64":
                                int intV = 0;
                                int.TryParse(ds.Tables[0].Rows[i][j].ToString(), out intV);
                                dataRow.CreateCell(j).SetCellValue(intV);
                                break;
                            case "System.Decimal"://float
                            case "System.Double":
                                double doubV = 0;
                                double.TryParse(ds.Tables[0].Rows[i][j].ToString(), out doubV);
                                dataRow.CreateCell(j).SetCellValue(doubV);
                                break;
                            case "System.DateTime"://datetime
                                DateTime DateTimeV;
                                DateTime.TryParse(ds.Tables[0].Rows[i][j].ToString(), out DateTimeV);
                                dataRow.CreateCell(j).SetCellValue(DateTimeV);
                                break;
                            case "System.DBNull":
                                dataRow.CreateCell(j).SetCellValue("");
                                break;
                            default://string
                                dataRow.CreateCell(j).SetCellValue(ds.Tables[0].Rows[i][j].ToString());
                                break;
                        }

                        try
                        {
                            dataRow.GetCell(j).CellStyle = sheet.GetRow(HeaderRowIndex + 1).GetCell(j).CellStyle;
                        }
                        catch (Exception ex)
                        {
                        }

                    }
                }
                try
                {
                    sheet.ShiftRows((HeaderRowIndex + 2), sheet.LastRowNum, -1);
                }
                catch (Exception ex)
                {
                }

                return hssfworkbook;                
            }

        }


        /// <summary>
        /// DataSetеݵExcel,浽ָ·
        /// </summary>
        /// <param name="ds">ҪݣDataSetʽ</param>
        /// <param name="TemplateUrl">ģļ·</param>
        /// <param name="SheetName"></param>
        /// <param name="HeaderRowIndex">ͷ</param>
        /// <param name="XLSSavePath">·</param>
        /// <returns></returns>
        public static void DataSetExportToExcel(DataSet ds, string TemplateUrl, string SheetName, int HeaderRowIndex, string XLSSavePath)
        {
            HSSFWorkbook hssfworkbook = DataSetExportToExcel(ds, TemplateUrl, SheetName, HeaderRowIndex);
            //Ϊ
            using (FileStream f = new FileStream(HttpContext.Current.Server.MapPath("~" + XLSSavePath), FileMode.Create, FileAccess.ReadWrite))
            {
                hssfworkbook.Write(f);
            }
        }


        /// <summary>
        /// DataSetеݵExcel
        /// </summary>
        /// <param name="ds">ҪݣDataSetʽ</param>
        /// <param name="TemplateUrl">ģļ·</param>
        /// <param name="SheetName"></param>
        /// <param name="HeaderRowIndex">ͷ</param>
        /// <returns></returns>
        public static HSSFWorkbook DataSetExportToExcel(DataTable ds, string TemplateUrl, string SheetName, int HeaderRowIndex)
        {

            HSSFWorkbook hssfworkbook = CreateWorkbook(TemplateUrl);
            if (SheetName == "")
            {
                SheetName = "Sheet1";
            }
            ISheet sheet = hssfworkbook.GetSheet(SheetName);

            using (FileStream file = new FileStream(HttpContext.Current.Server.MapPath(TemplateUrl), FileMode.Open, FileAccess.Read))
            {
                IRow dataRow;
                for (int i = 0; i < ds.Rows.Count; i++)
                {
                    dataRow = sheet.CreateRow(i + HeaderRowIndex + 2);
                    dataRow.HeightInPoints = sheet.GetRow(HeaderRowIndex + 1).HeightInPoints;
                    for (int j = 0; j < ds.Columns.Count; j++)
                    {
                        if (ds.Rows[i][j].ToString().Trim() == "")
                        {
                            continue;
                        }

                        switch (ds.Columns[j].DataType.ToString())
                        {
                            case "System.Int16"://integer
                            case "System.Int32":
                            case "System.Int64":
                                int intV = 0;
                                int.TryParse(ds.Rows[i][j].ToString(), out intV);
                                dataRow.CreateCell(j).SetCellValue(intV);
                                break;
                            case "System.Decimal"://float
                            case "System.Double":
                                double doubV = 0;
                                double.TryParse(ds.Rows[i][j].ToString(), out doubV);
                                dataRow.CreateCell(j).SetCellValue(doubV);
                                break;
                            case "System.DateTime"://datetime
                                DateTime DateTimeV;
                                DateTime.TryParse(ds.Rows[i][j].ToString(), out DateTimeV);
                                dataRow.CreateCell(j).SetCellValue(DateTimeV);
                                break;
                            case "System.DBNull":
                                dataRow.CreateCell(j).SetCellValue("");
                                break;
                            default://string
                                dataRow.CreateCell(j).SetCellValue(ds.Rows[i][j].ToString());
                                break;
                        }

                        try
                        {
                            dataRow.GetCell(j).CellStyle = sheet.GetRow(HeaderRowIndex + 1).GetCell(j).CellStyle;
                        }
                        catch (Exception ex)
                        {
                        }

                    }
                }
                try
                {
                    sheet.ShiftRows((HeaderRowIndex + 2), sheet.LastRowNum, -1);
                }
                catch (Exception ex)
                {
                }

                return hssfworkbook;
            }

        }


        /// <summary>
        /// DataSetеݵExcel,浽ָ·
        /// </summary>
        /// <param name="ds">ҪݣDataSetʽ</param>
        /// <param name="TemplateUrl">ģļ·</param>
        /// <param name="SheetName"></param>
        /// <param name="HeaderRowIndex">ͷ</param>
        /// <param name="XLSSavePath">·</param>
        /// <returns></returns>
        public static void DataSetExportToExcel(DataTable ds, string TemplateUrl, string SheetName, int HeaderRowIndex, string XLSSavePath)
        {
            HSSFWorkbook hssfworkbook = DataSetExportToExcel(ds, TemplateUrl, SheetName, HeaderRowIndex);
            //Ϊ
            using (FileStream f = new FileStream(HttpContext.Current.Server.MapPath("~" + XLSSavePath), FileMode.Create, FileAccess.ReadWrite))
            {
                hssfworkbook.Write(f);
            }
        }


        /// <summary>
        /// Excelļ
        /// </summary>
        /// <param name="hssfworkbook">NPOI</param>
        /// <param name="DefaultName">Ĭļ</param>
        public static void DownloadExcelFile(HSSFWorkbook hssfworkbook, string DefaultName)
        {
            HttpContext.Current.Response.ContentType = "application/vnd.ms-excel";
            HttpContext.Current.Response.AppendHeader("Content-Disposition", "attachment;filename=" + System.Web.HttpUtility.UrlEncode(DefaultName));
            HttpContext.Current.Response.Clear();
            MemoryStream file = new MemoryStream();
            hssfworkbook.Write(file);
            file.WriteTo(HttpContext.Current.Response.OutputStream);
            HttpContext.Current.Response.End();
        }

    }
}

